/* 
alice.c 
ALICE V 2.0, January 1993
main program 
(C) Ralf Kaufmann 1993 
used C compiler: Pure C 
*/ 
 
#include <ctype.h> 
#include <gem.h> 
#include <osbind.h> 
#include <stdio.h> 
#include <stdlib.h> 
#include <string.h> 
#include "language.h" 
#include "prvdef.h" 
#include "mewidi.h" 
#include "messages.h" 
#include "scancode.h" 
#include "structs.h" 
#include "rsc.h" 

/* References to global data defined elsewhere  */ 
 
extern  WIND_DATA   windows[]; 
extern  int         prgquit, prgexit; 
extern  char        param_filename[]; 
extern  char        prg_path[]; 
extern  OBJECT      *menu_tree; 
extern  long        param_line;
extern  int         from_page, to_page, page_offset, clocky;
 
// Function-Prototypes
int cfg_read(void);
int cfg_write(void);
void display_time(short flag); 
void gem_exit(int rsrc); 
int gem_init(void); 
int handle_keybd(int key); 
short handle_menu(short title, short item); 
int handle_mouse(int x, int y, int button); 
int handle_window(short msg_buffer[]); 
void put_message(int msg_nr);

 
/**********************/ 
/* Start of routines  */ 
/**********************/ 
 
 
 
 
int main(int argc, char *argv[]) 
{ 
  char  default_path[FSEL_MAX_PATH_LEN]; 
 
  short prv_event;                    /* private event return code  */ 
  short i; 
  short ev_mflags, ev_mbclicks, ev_mbmask, ev_mbstate; 
  short ev_mm1flags, ev_mm1x, ev_mm1y, ev_mm1width, ev_mm1height; 
  short ev_mm2flags, ev_mm2x, ev_mm2y, ev_mm2width, ev_mm2height; 
  short ev_mmgpbuff[MSG_BUFFER]; 
  short ev_mtlocount, ev_mthicount; 
  short ev_mmox, ev_mmoy, ev_mmobutton, ev_mmokstate; 
  short ev_mkreturn, ev_mbreturn; 

  prgquit = prgexit = FALSE; 
 
  for (i = 0; i < WD_MAX_WINDOWS; i++) windows[i].handle = -1; 
 
  strcpy (param_filename, ""); 
  param_line = 0;
  
  if (argc > 1 )
  { 
    strcpy (param_filename, argv[1]);
		if (param_filename[0] == '-') strcpy (param_filename, "");
  }
  
  if (argc > 2 )									/* program path was specified	*/
  { 
    strcpy (prg_path, argv[2]); 
    for (i = 0; i < strlen (prg_path); i++) 
    { 
      if (isalpha ((int) prg_path[i])) 
      { 
        prg_path[i] = (char) toupper ((int) prg_path[i]); 
      } 
    } 
	  if ((strrchr (prg_path, '\\')) != NULL) 
  	{                               /* parameter contains path info */ 
    	if (prg_path[1] == ':') 
    	{
    		Dsetdrv (prg_path[0] - 'A'); 
		  }
		  Dsetpath ("\\");
    	Dsetpath (prg_path); 
  	} 
  }
  
	/* check the existence of the rsc file before 	*/
	/* doing anything else													*/
	
	if (Fsfirst (RSC_FILE, 0) < 0)
	{
		prg_path[0] = Dgetdrv () + 'A';
		prg_path[1] = ':';
  	Dgetpath (prg_path + 2, 0); 
		put_message (NO_RSC);
		exit (0);
	}
  
  from_page   = 1;
  to_page     = 999;
  page_offset = 0;
  
  if (!cfg_read ())                 /* configuration initialization */
  {
    put_message (ERR_CFG_READ);
  }
  if (!gem_init ())                         /* init the application */ 
  { 
    MOUSE_IS_ARROW; 
    put_message (GEM_INIT_ERROR); 
    gem_exit (FALSE);           /* what a pity, try again later...  */ 
  } 
  MOUSE_IS_ARROW; 
  wind_update (BEG_UPDATE); 

  if (argc > 1 )
  { 
    param_line = 0; 
  }

  if (strlen (param_filename) > 0) 
                      /* open a window if an argument is specified  */ 
  { 
    for (i = 0; i < strlen (param_filename); i++) 
    { 
      if (isalpha ((int) param_filename[i])) 
      { 
        param_filename[i] = (char) toupper ((int) param_filename[i]); 
      } 
    } 
    if ((strrchr (param_filename, '\\')) != NULL) 
    {                               /* parameter contains path info */ 
      if (param_filename[1] == ':') 
      {
      	Dsetdrv (param_filename[0] - 'A'); 
      }
      strcpy (default_path, param_filename); 
      strcpy (strrchr (default_path, '\\') + 1, "\0"); 
      Dsetpath (default_path); 
      strcpy (default_path, param_filename);   /* strip off path */ 
      strcpy (param_filename, strrchr (default_path, '\\') + 1); 
    } 
    while (strrchr (param_filename, '\n') != NULL)
    {
      strcpy (strrchr (param_filename, '\n'), "\0");
    }
    menu_tnormal (menu_tree, TFILE, FALSE); 
    handle_menu ((int) TFILE, (int) IOPEN); 
  } 
  strcpy (param_filename, ""); 
  param_line = 0; 
  wind_update (END_UPDATE); 
                                /* define the events to wait for    */ 
  ev_mflags     = MU_MESAG | MU_BUTTON | MU_KEYBD | MU_TIMER; 
  ev_mbclicks   = 1;          /* one mouseclick required for event  */ 
  ev_mbmask     = 1;          /* wait for left button...            */ 
  ev_mbstate    = 1;          /* ...to be pressed                   */ 
  ev_mm1flags   = 0; 
  ev_mm1x       = 0; 
  ev_mm1y       = 0; 
  ev_mm1width   = 0; 
  ev_mm1height  = 0; 
  ev_mm2flags   = 0; 
  ev_mm2x       = 0; 
  ev_mm2y       = 0; 
  ev_mm2width   = 0; 
  ev_mm2height  = 0; 
  ev_mtlocount  = 30000;        /* timer = 30 secs  */ 
  ev_mthicount  = 0; 
 
  do                                    /* here comes the main loop */ 
  { 
	  prv_event = evnt_multi (ev_mflags, ev_mbclicks, ev_mbmask, 
                            ev_mbstate, ev_mm1flags, ev_mm1x, 
                            ev_mm1y, ev_mm1width, ev_mm1height, 
                            ev_mm2flags, ev_mm2x, ev_mm2y, 
                            ev_mm2width, ev_mm2height, ev_mmgpbuff, 
                            ev_mtlocount, /*ev_mthicount,*/ &ev_mmox, 
                            &ev_mmoy, &ev_mmobutton, &ev_mmokstate, 
                            &ev_mkreturn, &ev_mbreturn); 
    if (prv_event & MU_MESAG) 
    { 
      if (ev_mmgpbuff[0] == MN_SELECTED) 
      { 
        handle_menu(ev_mmgpbuff[3], ev_mmgpbuff[4]); 
      } 
      else                            /* Note: As the function    */ 
      {                               /* handle_keybd sends       */ 
        handle_window(ev_mmgpbuff); 
                                      /* messages to be handled   */ 
      }                               /* by handle_window, it is  */ 
    }                                 /* crucial to call this     */ 
                                      /* function before          */ 
    if (prv_event & MU_KEYBD)         /* handle_keybd (there      */ 
    {                                 /* might be several events  */ 
      handle_keybd(ev_mkreturn); 
                                      /* pending that must be     */ 
    }                                 /* dealt with in one loop)  */ 

    if (prv_event & MU_BUTTON) 
    { 
      handle_mouse(ev_mmox, ev_mmoy, ev_mmobutton); 
    } 

    if (prv_event & MU_TIMER) 
    { 
			srand(rand());
      if (clocky) 	display_time(TRUE); 
    }
  } 
  while(!prgexit);

  wind_update(BEG_UPDATE);
  if (!cfg_write())            /* save the configuration settings  */ 
  {
    put_message(ERR_CFG_WRITE);
  }

  wind_update(END_UPDATE);
  gem_exit(TRUE); 
  return (TRUE);              /* this statement is never executed */ 
}                                           /* end function main  */ 
 
 
 
/* end of file alice.c */ 
 
