/* 
buffer.c 
ALICE V 2.0, January 1993
library functions for menu handling 
(C) Ralf Kaufmann 1993
used C compiler: Pure C 
*/ 
 
/* Includefiles */ 
 
#include <gem.h> 
#include <stdio.h> 
#include "language.h" 
#include "prvdef.h" 
#include "mewidi.h" 
#include "messages.h" 
#include "scancode.h" 
#include "structs.h" 
#include "rsc.h" 
 
/* References to global data defined elsewhere  */ 
 
extern  WIND_DATA   windows[]; 
extern  BUFFER      buffers[]; 
extern  OBJECT      *menu_tree; 
extern  OBJECT      *dial_about, *dial_help, *dial_print, *dial_tab; 
extern  OBJECT      *dial_search, *dial_replace, *dial_goto; 
extern  OBJECT      *dial_info, *dial_selebuf, *dial_linelen; 
extern  OBJECT      *dial_repl_info; 

extern  int   page_length, left_margin; 
extern  int   tab_size, backup, clocky, header, lines;
extern  int   showcr, showpos; 
extern  char  param_filename[FSEL_MAX_PATH_LEN+FSEL_MAX_FILNAM_LEN]; 
extern  long  param_line; 
extern  int   buffer_index;
extern  int   line_len, eol_warn; 
 

// Function-Prototypes
short block_set(short w_index); 
int exist_buffer(void); 


/**********************/ 
/* Start of routines  */ 
/**********************/ 
 
 
 
 
void cap_enable(int flag)   /* enables/disables cut and paste entries */ 
//int   flag; 
{ 
  menu_ienable (menu_tree, IBLCUT,  flag); 
  menu_ienable (menu_tree, IBLCOPY, flag); 
  menu_ienable (menu_tree, IBLDELE, flag); 
  menu_ienable (menu_tree, IBLCANC, flag); 
  return; 
} 
 
 
 
 
void buf_enable(int flag) /* enables/disables buffer related entries  */ 
//int   flag; 
{ 
 	menu_ienable (menu_tree, IBLPASTE, flag); 
  menu_ienable (menu_tree, ICLBUFF,  flag); 
  return; 
} 
 
 
 
 
void cap_check(int w_index) /* checks for block/buffer definitions  */ 
                          /* and sets menue entries accordingly   */ 
//int   w_index;            /* window index */ 
{ 

  if (w_index < 0) return;
  if (exist_buffer ()) 
  { 
    buf_enable (TRUE); 
  } 
  else 
  { 
    buf_enable (FALSE); 
  } 
  if (block_set (w_index)) 
  { 
    cap_enable (TRUE); 
    menu_ienable (menu_tree, IREPL, FALSE); 
    menu_ienable (menu_tree, IRDFILFI, FALSE); 
    menu_ienable (menu_tree, IBLPASTE, FALSE);
  } 
  else 
  {
    cap_enable (FALSE); 
    menu_ienable (menu_tree, IREPL, TRUE); 
    menu_ienable (menu_tree, IRDFILFI, TRUE); 
    if (exist_buffer ()) 
    {
      menu_ienable (menu_tree, IBLPASTE, TRUE);
    } 
  } 
  return; 
} 
 


void save_buffer_names(void)
{
  TEDINFO     *ted_info; 

  ted_info = dial_selebuf[BUFNAM1].ob_spec.tedinfo; 
  strcpy (buffers[0].bufnam, ted_info->te_ptext); 
  ted_info = dial_selebuf[BUFNAM2].ob_spec.tedinfo; 
  strcpy (buffers[1].bufnam, ted_info->te_ptext); 
  ted_info = dial_selebuf[BUFNAM3].ob_spec.tedinfo; 
  strcpy (buffers[2].bufnam, ted_info->te_ptext); 
  ted_info = dial_selebuf[BUFNAM4].ob_spec.tedinfo; 
  strcpy (buffers[3].bufnam, ted_info->te_ptext); 
  ted_info = dial_selebuf[BUFNAM5].ob_spec.tedinfo; 
  strcpy (buffers[4].bufnam, ted_info->te_ptext); 
  ted_info = dial_selebuf[BUFNAM6].ob_spec.tedinfo; 
  strcpy (buffers[5].bufnam, ted_info->te_ptext); 
  ted_info = dial_selebuf[BUFNAM7].ob_spec.tedinfo; 
  strcpy (buffers[6].bufnam, ted_info->te_ptext); 
  ted_info = dial_selebuf[BUFNAM8].ob_spec.tedinfo; 
  strcpy (buffers[7].bufnam, ted_info->te_ptext); 
  ted_info = dial_selebuf[BUFNAM9].ob_spec.tedinfo; 
  strcpy (buffers[8].bufnam, ted_info->te_ptext); 
  ted_info = dial_selebuf[BUFNAM10].ob_spec.tedinfo; 
  strcpy (buffers[9].bufnam, ted_info->te_ptext); 

  return;
} 



void restore_buffer_names(void)
{
  TEDINFO     *ted_info; 

  ted_info = dial_selebuf[BUFNAM1].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, buffers[0].bufnam); 
  ted_info = dial_selebuf[BUFNAM2].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, buffers[1].bufnam); 
  ted_info = dial_selebuf[BUFNAM3].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, buffers[2].bufnam); 
  ted_info = dial_selebuf[BUFNAM4].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, buffers[3].bufnam); 
  ted_info = dial_selebuf[BUFNAM5].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, buffers[4].bufnam); 
  ted_info = dial_selebuf[BUFNAM6].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, buffers[5].bufnam); 
  ted_info = dial_selebuf[BUFNAM7].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, buffers[6].bufnam); 
  ted_info = dial_selebuf[BUFNAM8].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, buffers[7].bufnam); 
  ted_info = dial_selebuf[BUFNAM9].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, buffers[8].bufnam); 
  ted_info = dial_selebuf[BUFNAM10].ob_spec.tedinfo; 
  strcpy (ted_info->te_ptext, buffers[9].bufnam);

  return;
  
}

/* end of buffer.c  */
