/* 
shortcut.c 
ALICE V 2.0, January 1993
library functions for shortcut handling 
(C) Ralf Kaufmann 1993 
used C compiler: Pure C 
*/ 
 
/* Includefiles */ 
 
#define __GEMLIB_OLDNAMES
# include <gem.h> 
# include <stdio.h> 
# include "language.h" 
# include "prvdef.h" 
# include "mewidi.h" 
# include "messages.h" 
# include "scancode.h" 
# include "structs.h" 
# include "rsc.h" 
 
/* References to global data defined elsewhere  */ 
 
extern  WIND_DATA   windows[]; 
extern  int         tab_size, closeall; 
extern  OBJECT      *menu_tree; 
 
// Funktionsprototypen
int alternate_key(void);
int control_key(void);
short get_index_from_handle(short w_handle); 
void goto_line(short w_index, long line);
short handle_menu(short title, short item); 
int top_wind(void); 
int udf(void);

/**********************/ 
/* Start of routines  */ 
/**********************/ 
 
 
 
 
int handle_shortcut(int key) 
//int   key; 
{ 
  unsigned    char        scan_hi, scan_lo; 

  char 				prg_info_text[ALERT_MAX_LINES*ALERT_MAX_LINE_LENGTH]; 
  int         w_index, w_handle; 

  

  scan_lo = key & 0x00FF; 
  scan_hi = (key >> 8) & 0x00FF; 
 
  if (scan_hi == HI_ALT_O && scan_lo == LO_ALT_O)  /* open  */ 
  { 
    if (menu_tree[IOPEN].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TFILE, FALSE); 
    handle_menu ((int ) TFILE, (int ) IOPEN); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_ALT_N && scan_lo == LO_ALT_N)  /* include  */ 
  { 
    if (menu_tree[IRDFILFI].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TFILE, FALSE); 
    handle_menu ((int ) TFILE, (int ) IRDFILFI); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_ALT_P && scan_lo == LO_ALT_P)  /* print */ 
  { 
    if (menu_tree[IFIPRINT].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TFILE, FALSE); 
    handle_menu ((int ) TFILE, (int ) IFIPRINT); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_ALT_B && scan_lo == LO_ALT_B)  /* backup */ 
  { 
    if (menu_tree[IBACK].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TFILE, FALSE); 
    handle_menu ((int ) TFILE, (int ) IBACK); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_ALT_K && scan_lo == LO_ALT_K)  /* backup as */ 
  { 
    if (menu_tree[IBACKAS].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TFILE, FALSE); 
    handle_menu ((int ) TFILE, (int ) IBACKAS); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_ALT_S && scan_lo == LO_ALT_S)  /* save */ 
  { 
    if (menu_tree[ISAVE].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TFILE, FALSE); 
    handle_menu ((int ) TFILE, (int ) ISAVE); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_ALT_G && scan_lo == LO_ALT_G)  /* save as */ 
  { 
    if (menu_tree[ISAVEAS].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TFILE, FALSE); 
    handle_menu ((int ) TFILE, (int ) ISAVEAS); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_ALT_I && scan_lo == LO_ALT_I)  /* doc info */ 
  { 
    if (menu_tree[IDOCINFO].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TEXTRAS, FALSE); 
    handle_menu ((int ) TEXTRAS, (int ) IDOCINFO); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_ALT_C && scan_lo == LO_ALT_C)  /* close  */ 
  { 
    if (menu_tree[ICLOSE].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TBLOCK, FALSE); 
    handle_menu ((int ) TBLOCK, (int ) ICLOSE); 
    return (TRUE); 
  } 

  if (scan_hi == HI_ALT_U && scan_lo == LO_ALT_U)  /* close all */ 
  { 
    if (menu_tree[ICLOSALL].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TBLOCK, FALSE); 
    handle_menu ((int ) TBLOCK, (int ) ICLOSALL); 
    return (TRUE); 
  } 

  if ((scan_hi == HI_SF10   && scan_lo == LO_SF10)  || 
      (scan_hi == HI_CTRL_Q  && scan_lo == LO_CTRL_Q))  /* quit   */ 
  { 
    if (menu_tree[IQUIT].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TFILE, FALSE); 
    handle_menu ((int ) TFILE, (int ) IQUIT); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_CTRL_X && scan_lo == LO_CTRL_X)  /* cut  */ 
  { 
    if (menu_tree[IBLCUT].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TBLOCK, FALSE); 
    handle_menu ((int ) TBLOCK, (int ) IBLCUT); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_ALT_M && scan_lo == LO_ALT_M) /* cancel marks */ 
  { 
    if (menu_tree[IBLCANC].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TBLOCK, FALSE); 
    handle_menu ((int ) TBLOCK, (int ) IBLCANC); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_ALT_R && scan_lo == LO_ALT_R)  
                                        /* read file into buffer */ 
  { 
    if (menu_tree[IRDFILBU].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TBLOCK, FALSE); 
    handle_menu ((int ) TBLOCK, (int ) IRDFILBU); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_ALT_E && scan_lo == LO_ALT_E) /* clear buffer */ 
  { 
    if (menu_tree[ICLBUFF].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TBLOCK, FALSE); 
    handle_menu ((int ) TBLOCK, (int ) ICLBUFF); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_CTRL_D && scan_lo == LO_CTRL_D) 
                                                  /* delete block */ 
  { 
    if (menu_tree[IBLDELE].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TBLOCK, FALSE); 
    handle_menu ((int ) TBLOCK, (int ) IBLDELE); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_CTRL_C && scan_lo == LO_CTRL_C)  /* copy  */ 
  { 
    if (menu_tree[IBLCOPY].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TBLOCK, FALSE); 
    handle_menu ((int ) TBLOCK, (int ) IBLCOPY); 
    return (TRUE); 
  } 
  
  if (scan_hi == HI_CTRL_R && scan_lo == LO_CTRL_R)  /* replace  */ 
  { 
    if (menu_tree[IREPL].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TSEARCH, FALSE); 
    handle_menu ((int ) TSEARCH, (int ) IREPL); 
    return (TRUE); 
  } 

  if (scan_hi == HI_CTRL_V && scan_lo == LO_CTRL_V)  /* paste */ 
  { 
    if (menu_tree[IBLPASTE].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TBLOCK, FALSE); 
    handle_menu ((int ) TBLOCK, (int ) IBLPASTE); 
    return (TRUE); 
  } 

  if (scan_hi == HI_CTRL_L && scan_lo == LO_CTRL_L)  /* goto line  */
  { 
    if (menu_tree[IGOTOLI].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TSEARCH, FALSE); 
    handle_menu ((int ) TSEARCH, (int ) IGOTOLI); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_CTRL_P && scan_lo == LO_CTRL_P)  /* goto page  */
  { 
    if (menu_tree[IGOTOPA].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TSEARCH, FALSE); 
    handle_menu ((int ) TSEARCH, (int ) IGOTOPA); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_ALT_T && scan_lo == LO_ALT_T)  /* options  */ 
  { 
    if (menu_tree[IOPTIONS].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TEXTRAS, FALSE); 
    handle_menu ((int ) TEXTRAS, (int ) IOPTIONS); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_ALT_D && scan_lo == LO_ALT_D)  /* delete file  */ 
  { 
    if (menu_tree[IFIDELE].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TEXTRAS, FALSE); 
    handle_menu ((int ) TEXTRAS, (int ) IFIDELE); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_ALT_A && scan_lo == LO_ALT_A)  
                                              /* buffer selection */ 
  { 
    if (menu_tree[ISELEBUF].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TBLOCK, FALSE); 
    handle_menu ((int ) TBLOCK, (int ) ISELEBUF); 
    return (TRUE); 
  } 
 
  if ((scan_hi == HI_HELP) ||
      (scan_hi == HI_CTRL_K && scan_lo == LO_CTRL_K)) 
                                              /* help keybord */ 
  { 
    if (menu_tree[IHELPKBD].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, THELP, FALSE); 
    handle_menu ((int ) THELP, (int ) IHELPKBD); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_CTRL_T && scan_lo == LO_CTRL_T) 
                                              /* help file  */ 
  { 
    if (menu_tree[IHELPFI].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, THELP, FALSE); 
    handle_menu ((int ) THELP, (int ) IHELPFI); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_CTRL_O && scan_lo == LO_CTRL_O)
                                              /* help block */ 
  { 
    if (menu_tree[IHELPBL].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, THELP, FALSE); 
    handle_menu ((int ) THELP, (int ) IHELPBL); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_CTRL_M && scan_lo == LO_CTRL_M)
                                              /* help mouse */ 
  { 
    if (menu_tree[IHELPMS].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, THELP, FALSE); 
    handle_menu ((int ) THELP, (int ) IHELPMS); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_CTRL_I && scan_lo == LO_CTRL_I) 
                                              /* help windows */ 
  { 
    if (menu_tree[IHELPWI].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, THELP, FALSE); 
    handle_menu ((int ) THELP, (int ) IHELPWI); 
    return (TRUE); 
  } 

  if (scan_hi == HI_ALT_L 	&& scan_lo == LO_ALT_L)
  {
  	MOUSE_IS_ARROW; 
		sprintf (prg_info_text, 
			"[1]["
			" ALICE Version %s |"
			" Date of program creation: |"
			" %s at %s |"
			" \275 1992/93 by %s"
			"][ OK ]",
			ALICE_VERSION, __DATE__, __TIME__, ALICE_AUTHOR); 
  	form_alert (1, prg_info_text); 
  	BMJDF;
		return (TRUE);
  }
 
  if ((w_handle = top_wind ()) == -1) return (TRUE); 
  w_index = get_index_from_handle (w_handle); 
 
  if (scan_hi == HI_F1 && scan_lo == LO_F1) 
  { 
    scan_hi = HI_SCUDOWN;           /* shift cursor down   */ 
    scan_lo = LO_SCUDOWN; 
  } 
 
  if (scan_hi == HI_F2 && scan_lo == LO_F2) 
  { 
    scan_hi = HI_SCUUP;             /* shift cursor up     */ 
    scan_lo = LO_SCUUP; 
  } 
 
  if ((scan_hi == HI_F3     && scan_lo == LO_F3) || /* block start  */ 
      (scan_hi == HI_CTRL_S && scan_lo == LO_CTRL_S))
  { 
    if (menu_tree[IBLSTART].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TBLOCK, FALSE); 
    handle_menu ((int ) TBLOCK, (int ) IBLSTART); 
    return (TRUE); 
  } 
 
  if ((scan_hi == HI_F4     && scan_lo == LO_F4) || /* block end  */ 
      (scan_hi == HI_CTRL_E && scan_lo == LO_CTRL_E))
  { 
    if (menu_tree[IBLEND].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TBLOCK, FALSE); 
    handle_menu ((int ) TBLOCK, (int ) IBLEND); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_CTRL_F && scan_lo == LO_CTRL_F) /* search  */ 
  { 
    if (menu_tree[ISEARCH].ob_state & DISABLED) return (TRUE);
    menu_tnormal (menu_tree, TSEARCH, FALSE); 
    handle_menu ((int ) TSEARCH, (int ) ISEARCH); 
    return (TRUE); 
  } 

  if ((scan_hi == HI_F10    && scan_lo == LO_F10) ||
      (scan_hi == HI_CTRL_A && scan_lo == LO_CTRL_A)) 
                                                  /* repeat search  */ 
  { 
    if (menu_tree[IREPSEAR].ob_state & DISABLED) return (TRUE);
    handle_menu ((int ) TBLOCK, (int ) IREPSEAR); 
    return (TRUE); 
  } 
 
  if (scan_hi == HI_SF3 && scan_lo == LO_SF3)  
                                      /* goto beginning of block  */ 
  { 
    if (windows[w_index].block.set) 
    {
      goto_line(w_index, windows[w_index].block.cs_y);
    }
    return (TRUE); 
  } 
 
  if (scan_hi == HI_SF4 && scan_lo == LO_SF4)  
                                      /* goto end of block  */ 
  { 
    if (windows[w_index].block.set) 
    {
      goto_line (w_index, windows[w_index].block.ce_y);
    }
    return (TRUE); 
  } 
  return (TRUE); 
}                             /* end function handle_shortcut     */ 
 
 
 
/* end of file shortcut.c */ 
 
